IE1		 		.equ	 0h
IE2		 		.equ	 01h
IFG1			.equ	 02h
IFG2			.equ	 03h
P1OUT			.equ	 021h
P1DIR			.equ	 022h
WDTCTL			.equ	 0120h
WDT_WrKey		.equ	 05A00h
WDT_HOLD		.equ	 080h

RAM_orig  .set		 00200h		 ; Free Memory start address
ROM_orig  .set		 0FC00h		 ; ROM start address
USER_END  .set		 0FFFFh		 ; RAM end address
SP_orig   .set		 00280h		 ; stackpointer

;************************************************************************
; Reset : Initialize processor
;************************************************************************

	 .sect "MAIN",ROM_orig
RESET
	 mov #SP_orig,SP				   ; initialize stackpointer
	 mov #(WDT_HOLD+WDT_WrKey),&WDTCTL  ; Stop Watchdog Timer

;--- Clear Special Function Registers
	 clr.b  &IE1
	 clr.b  &IE2
	 clr.b  &IFG1
	 clr.b  &IFG2

	 mov.b #010h,&P1DIR

;******************************************************************************
; Mainloop
;******************************************************************************

LoopTop
	 xor.b #010h,&P1OUT	  ; Toggle P1.4	
	 jmp LoopTop

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; Interrupt vectors
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	.sect	  "Int_Vect",USER_END-31
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; no source
	.word	  RESET				  ; NMI, Osc. fault
	.word	  RESET				  ; POR, ext. Reset, Watchdog
	.end
