// TwiddlerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Twiddler.h"
#include "TwiddlerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_BLMSPF		(WM_USER+100)
#define	FILE_RD_FLAGS	(OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT)
#define	FILE_FLAGS		(OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST)
#define FILE_FILTER		"TI Text Files (*.txt)|*.txt|Intel Hex Files (*.hex)|*.hex||"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwiddlerDlg dialog

CTwiddlerDlg::CTwiddlerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTwiddlerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTwiddlerDlg)
	m_strPort = _T("");
	m_strTargetInfo = _T("Unknown Target");
	m_strAdapterInfo = _T("Unknown Adapter");
	m_strDLLInfo = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTwiddlerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTwiddlerDlg)
	DDX_Control(pDX, IDC_SAMPLE_BLTGTSIG, m_ctlSampleBLTGTSIG);
	DDX_Control(pDX, IDC_SET_P13, m_ctlSetP13);
	DDX_Control(pDX, IDC_CLEAR_P13, m_ctlClearP13);
	DDX_Control(pDX, IDC_CONFIGURE, m_ctlConfigure);
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Control(pDX, IDC_PROMPT, m_ctlPrompt);
	DDX_Control(pDX, IDC_POWER_OFF, m_btnPowerOff);
	DDX_Control(pDX, IDC_WRITE_STUBS, m_btnWriteStubs);
	DDX_Control(pDX, IDC_RESET_TARGET, m_btnResetTarget);
	DDX_Control(pDX, IDC_PORT, m_ctlPort);
	DDX_CBString(pDX, IDC_PORT, m_strPort);
	DDX_Text(pDX, IDC_TARGET_INFO, m_strTargetInfo);
	DDX_Text(pDX, IDC_ADAPTER_INFO, m_strAdapterInfo);
	DDX_Text(pDX, IDC_DLL_INFO, m_strDLLInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTwiddlerDlg, CDialog)
	ON_MESSAGE( WM_BLMSPF, OnBootloaderMessage )
	//{{AFX_MSG_MAP(CTwiddlerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_BN_CLICKED(IDC_WRITE_STUBS, OnWriteStubs)
	ON_BN_CLICKED(IDC_RESET_TARGET, OnResetTarget)
	ON_BN_CLICKED(IDC_POWER_OFF, OnPowerOff)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CLEAR_P13, OnClearP13)
	ON_BN_CLICKED(IDC_CONFIGURE, OnConfigure)
	ON_BN_CLICKED(IDC_SET_P13, OnSetP13)
	ON_BN_CLICKED(IDC_SAMPLE_BLTGTSIG, OnSampleBltgtsig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwiddlerDlg message handlers

BOOL CTwiddlerDlg::OnInitDialog()
{	BOOL bResult;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_strDLLInfo.Format( "DLL v. %s", GetVersion_BLMSPF() );

	ReadFromRegistry();
	bResult = OpenBLMSPF();
	if( FALSE == bResult )
	{	EnableControls( FALSE );
	}
		
	UpdateData( FALSE );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTwiddlerDlg::OnDestroy() 
{
	CloseBLMSPF();
	WriteToRegistry();
	CDialog::OnDestroy();
}

void CTwiddlerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTwiddlerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTwiddlerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTwiddlerDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CTwiddlerDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

void CTwiddlerDlg::OnClose() 
{
//	CDialog::OnClose();
	CDialog::OnOK();
}

void CTwiddlerDlg::EnableControls( BOOL bEnable )
{	static CWnd* pWndEnabled = NULL;

	if( FALSE == bEnable )
	{	pWndEnabled = GetFocus();
	}

	m_btnWriteStubs.EnableWindow( bEnable );
	m_btnResetTarget.EnableWindow( bEnable );
	m_btnPowerOff.EnableWindow( bEnable );
	m_ctlConfigure.EnableWindow( bEnable );
	m_ctlClearP13.EnableWindow( bEnable );
	m_ctlSetP13.EnableWindow( bEnable );
	m_ctlSampleBLTGTSIG.EnableWindow( bEnable );

	if( TRUE == bEnable )
	{	if( NULL != pWndEnabled )
		{	pWndEnabled->SetFocus();
		}
	}

	m_ctlProgress.SetPos( 0 );
	m_ctlProgress.SetRange( 0, 100 );
}

BOOL CTwiddlerDlg::BrowseFileName(	CString& strNewFileName, 
									LPCTSTR strFilter, 
									DWORD dwFlags,
									int* pnFilterIndex )
{	CFileDialog dlgFileOpen(	TRUE,
								"",
								strNewFileName,
								dwFlags,
								strFilter,
								this );

	*pnFilterIndex = 1;

	if( IDOK != dlgFileOpen.DoModal() )
	{	return FALSE;
	}

	strNewFileName = dlgFileOpen.GetPathName();
	*pnFilterIndex = dlgFileOpen.m_ofn.nFilterIndex;
	return TRUE;
}

BOOL CTwiddlerDlg::ReadFromRegistry()
{
	// Get comm port
	m_strPort = AfxGetApp()->GetProfileString( "Options", "Port", "COM1" );	

	// Get stubs file name
	m_strStubsFileName = AfxGetApp()->GetProfileString( "Options", "StubsFile", "TwiddleP13.txt" );	

	// Get patch file name
	m_strPatchFileName = AfxGetApp()->GetProfileString( "Options", "PatchFile", "Patch.txt" );	

	return TRUE;
}

BOOL CTwiddlerDlg::WriteToRegistry()
{
	// Save comm port
	AfxGetApp()->WriteProfileString( "Options", "Port", m_strPort );	

	// Save stubs file name
	AfxGetApp()->WriteProfileString( "Options", "StubsFile", m_strStubsFileName );	

	// Save patch file name
	AfxGetApp()->WriteProfileString( "Options", "PatchFile", m_strPatchFileName );	

	return TRUE;
}

void CTwiddlerDlg::OnSelchangePort() 
{	BOOL bResult;

	UpdateData( TRUE );

	// Reopen the bootload port	
	CloseBLMSPF();
	EnableControls( TRUE );
	bResult = OpenBLMSPF();
	if( FALSE == bResult )
	{	MessageBox( "Failed to open bootloader port.  Reopen before attempting to use application", "Comm Port Error" );
		EnableControls( FALSE );
	}	

	UpdateData( FALSE );
}

void CTwiddlerDlg::OnWriteStubs() 
{	BOOL bResult;
	int nFilterIndex, nFileType;

	if( !IsOpen_BLMSPF() )
	{	return;
	}

	bResult = BrowseFileName( m_strStubsFileName, FILE_FILTER, FILE_FLAGS, &nFilterIndex );
	if( FALSE == bResult )
	// Browse operation halted
	{	return;
	}

	UpdateData( TRUE );

	switch( nFilterIndex )
	{	case 2:
		// Intel hex file
			nFileType = BLMSPF_FILE_TYPE_INTEL_HEX;
			break;

		case 1:
		// Text file
			nFileType = BLMSPF_FILE_TYPE_TI_TEXT;
			break;

		default:
			return;
	}

	EnableControls( FALSE );
	WriteStubs( m_strStubsFileName, nFileType );
	EnableControls( TRUE );
}

void CTwiddlerDlg::OnResetTarget() 
{
	UpdateData( TRUE );

	EnableControls( FALSE );
	ResetTarget();
	EnableControls( TRUE );
}

void CTwiddlerDlg::OnPowerOff() 
{
	UpdateData( TRUE );

	EnableControls( FALSE );
	PowerOff();
	EnableControls( TRUE );
}

BOOL CTwiddlerDlg::OpenBLMSPF()
{	BOOL bResult;
	CString strMsg;
	char szError[MAX_BLMSPF_ERROR];

	RegisterHWND_BLMSPF( m_hWnd, WM_BLMSPF, BLMSPF_MSG_TYPE_ALL );

	bResult = Open_BLMSPF( m_strPort, DEFAULT_BLMSPF_BAUD );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		return FALSE;
	}

	bResult = SetPatchFile_BLMSPF( "Patch.txt" );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return FALSE;
	}

	InitializeAdapter();
	if( FALSE == bResult )
	{	return FALSE;
	}

	return TRUE;
}

void CTwiddlerDlg::CloseBLMSPF()
{
	Close_BLMSPF();
}

BOOL CTwiddlerDlg::InitializeAdapter()
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];
	WORD wAdapterVersion;
	DWORD dwAdapterSerNum;

	bResult = InitializeAdapter_BLMSPF();
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	GetAdapterInfo_BLMSPF( &wAdapterVersion, &dwAdapterSerNum );
	m_strAdapterInfo.Format( "Adapter v%02d.%02d, serial %06ld",
								HIBYTE( wAdapterVersion ),
								LOBYTE( wAdapterVersion ),
								dwAdapterSerNum );
	return bResult;
}

BOOL CTwiddlerDlg::SeizeTarget() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	bResult = InitializeTarget_BLMSPF( TRUE );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	return bResult;
}

BOOL CTwiddlerDlg::MassErase() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	bResult = MassErase_BLMSPF();
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	return bResult;
}

BOOL CTwiddlerDlg::ResetTarget() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	bResult = ResetTarget_BLMSPF();
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	return bResult;
}

BOOL CTwiddlerDlg::PowerOff() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	bResult = PowerOff_BLMSPF();
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	return bResult;
}

BOOL CTwiddlerDlg::SendPasswordFF() 
{	int nIndex;
	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	for( nIndex = 0; nIndex < BLMSPF_PASSWORD_LENGTH; nIndex++ )
	{	m_abyPassword[nIndex] = 0xFF;
	}

	bResult = SetPasswordData_BLMSPF( m_abyPassword );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return FALSE;
	}

	return TRUE;
}

void CTwiddlerDlg::WriteStubs( LPCTSTR szStubsFileName, int nFileType )
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	strcpy( szError, "" );

	// Seize the target
	bResult = SeizeTarget();
	if( FALSE == bResult )
	{	return;
	}

	// Mass-erase the target
	bResult = MassErase();
	if( FALSE == bResult )
	{	return;
	}

	// Send the FF password
	bResult = SendPasswordFF();
	if( FALSE == bResult )
	{	return;
	}

	// Get target information
	GetTargetInfo();

	// Perform the write operation
	bResult = WriteFile_BLMSPF( szStubsFileName, nFileType, FALSE );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
	}

	// Power off the target
	bResult = PowerOff();
	if( FALSE == bResult )
	{	return;
	}
}

void CTwiddlerDlg::GetTargetInfo()
{	CString strProcType;
	BYTE byMajorVersion, byMinorVersion;

	UpdateData( TRUE );
	GetBootloaderVersion_BLMSPF( &byMajorVersion, &byMinorVersion );
	strProcType = GetProcessorType_BLMSPF();
	m_strTargetInfo.Format( "Target %s, v %X.%X", strProcType, byMajorVersion, byMinorVersion );
	UpdateData( FALSE );
}

LONG CTwiddlerDlg::OnBootloaderMessage( UINT wParam, LONG lParam )
{
	if( NULL == lParam )
	{	return 0L;
	}

	switch( wParam )
	{	case BLMSPF_MSG_TYPE_TEXT:
			{	BLMSPF_MSG_TEXT* pbmt;

				pbmt = (BLMSPF_MSG_TEXT*)lParam;
				if( 0x00 != pbmt->szText[0] )
				{	m_ctlPrompt.SetWindowText( pbmt->szText );
					m_ctlPrompt.UpdateWindow();
				}
			}
			break;

		case BLMSPF_MSG_TYPE_PROGRESS:
			{	BLMSPF_MSG_PROGRESS* pbmp;

				pbmp = (BLMSPF_MSG_PROGRESS*)lParam;
				switch( pbmp->nProgressType )
				{	case BLMSPF_PROGRESS_TYPE_INIT_TARGET:
						m_ctlPrompt.SetWindowText( "Initializing target" );
						break;

					case BLMSPF_PROGRESS_TYPE_RESET_TARGET:
						m_ctlPrompt.SetWindowText( "Resetting target" );
						break;

					case BLMSPF_PROGRESS_TYPE_WRITE_FILE:
						m_ctlPrompt.SetWindowText( "Writing file" );
						break;

					case BLMSPF_PROGRESS_TYPE_READ_FILE:
						m_ctlPrompt.SetWindowText( "Reading file" );
						break;

					case BLMSPF_PROGRESS_TYPE_VERIFY_FILE:
						m_ctlPrompt.SetWindowText( "Verifying file" );
						break;
				}
				m_ctlPrompt.UpdateWindow();
			
				m_ctlProgress.SetPos( pbmp->nProgress );
				m_ctlProgress.SetRange( 0, pbmp->nMax );
			}
			break;
		
		default:
			break;
	}

	return 0L;
}

void CTwiddlerDlg::OnConfigure() 
{
	UpdateData( TRUE );

	EnableControls( FALSE );
	ConfigureP13();
	EnableControls( TRUE );
}

void CTwiddlerDlg::OnClearP13() 
{
	UpdateData( TRUE );

	EnableControls( FALSE );
	ClearP13();
	EnableControls( TRUE );
}

void CTwiddlerDlg::OnSetP13() 
{
	UpdateData( TRUE );

	EnableControls( FALSE );
	SetP13();
	EnableControls( TRUE );
}

BOOL CTwiddlerDlg::ConfigureP13() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	strcpy( szError, "" );

	// Seize the target
	bResult = SeizeTarget();
	if( FALSE == bResult )
	{	return FALSE;
	}

	// Send the FF password
	bResult = SendPasswordFF();
	if( FALSE == bResult )
	{	return FALSE;
	}

	// Get target information
	GetTargetInfo();

	// Execute the configure stub
	bResult = LoadPC_BLMSPF( 0xFFC0 );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return FALSE;
	}

	// Load the password again
	// Send the FF password
	bResult = SendPasswordFF();
	if( FALSE == bResult )
	{	return FALSE;
	}

	m_ctlPrompt.SetWindowText( "P1.3 configured" );
	return TRUE;
}

BOOL CTwiddlerDlg::ClearP13() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	strcpy( szError, "" );

	// Execute the clear stub
	bResult = LoadPC_BLMSPF( 0xFFC4 );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return FALSE;
	}

	// Load the password again
	// Send the FF password
	bResult = SendPasswordFF();
	if( FALSE == bResult )
	{	return FALSE;
	}

	m_ctlPrompt.SetWindowText( "P1.3 cleared" );
	return TRUE;
}

BOOL CTwiddlerDlg::SetP13() 
{	BOOL bResult;
	char szError[MAX_BLMSPF_ERROR];

	strcpy( szError, "" );

	// Execute the clear stub
	bResult = LoadPC_BLMSPF( 0xFFCC );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return FALSE;
	}

	// Load the password again
	// Send the FF password
	bResult = SendPasswordFF();
	if( FALSE == bResult )
	{	return FALSE;
	}

	m_ctlPrompt.SetWindowText( "P1.3 set" );
	return TRUE;
}

void CTwiddlerDlg::OnSampleBltgtsig() 
{	BOOL bResult, bTargetSignal;
	char szError[MAX_BLMSPF_ERROR];
	CString strSignal;

	strcpy( szError, "" );

	// Sample the target signal
	bResult = PollTargetSignal_BLMSPF( &bTargetSignal );
	if( FALSE == bResult )
	{	GetLastError_BLMSPF( szError, MAX_BLMSPF_ERROR );
		AfxMessageBox( szError );
		return;
	}

	strSignal.Format( "Target signal is %d", TRUE == bTargetSignal? 1 : 0 );
	m_ctlPrompt.SetWindowText( strSignal );
}
