// TwiddlerDlg.h : header file
//

#if !defined(AFX_TWIDDLERDLG_H__FD64FE67_822A_11D6_80D4_0050048A5DF5__INCLUDED_)
#define AFX_TWIDDLERDLG_H__FD64FE67_822A_11D6_80D4_0050048A5DF5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BLMSPF.h"

/////////////////////////////////////////////////////////////////////////////
// CTwiddlerDlg dialog

class CTwiddlerDlg : public CDialog
{
// Construction
public:
	CTwiddlerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTwiddlerDlg)
	enum { IDD = IDD_TWIDDLER_DIALOG };
	CButton	m_ctlSampleBLTGTSIG;
	CButton	m_ctlSetP13;
	CButton	m_ctlClearP13;
	CButton	m_ctlConfigure;
	CProgressCtrl	m_ctlProgress;
	CEdit	m_ctlPrompt;
	CButton	m_ctlVerifyWrites;
	CButton	m_btnPowerOff;
	CButton	m_btnWriteStubs;
	CButton	m_btnResetTarget;
	CComboBox	m_ctlPort;
	CString	m_strPort;
	CString	m_strTargetInfo;
	CString	m_strAdapterInfo;
	CString	m_strDLLInfo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTwiddlerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL ClearP13();
	BOOL ConfigureP13();
	BOOL SetP13();
	BOOL InitializeAdapter();
	void CloseBLMSPF();
	BOOL OpenBLMSPF();
	BOOL SeizeTarget(); 
	BOOL MassErase();
	BOOL ResetTarget();
	BOOL PowerOff();
	BOOL SendPasswordFF();
	void WriteStubs( LPCTSTR szStubFileName, int nFileType );
	void GetTargetInfo();
	BOOL WriteToRegistry();
	BOOL ReadFromRegistry();
	void EnableControls( BOOL bEnable );
	BOOL BrowseFileName(	CString& strNewFileName, 
							LPCTSTR strFilter, 
							DWORD dwFlags,
							int* pnFilterIndex );

	CString m_strPatchFileName;
	HICON m_hIcon;
	BYTE m_abyPassword[BLMSPF_PASSWORD_LENGTH];
	CString m_strStubsFileName;

	// Generated message map functions
	//{{AFX_MSG(CTwiddlerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnSelchangePort();
	afx_msg void OnWriteStubs();
	afx_msg void OnResetTarget();
	afx_msg void OnPowerOff();
	afx_msg void OnClose();
	afx_msg void OnClearP13();
	afx_msg void OnConfigure();
	afx_msg void OnSetP13();
	afx_msg void OnSampleBltgtsig();
	//}}AFX_MSG
	LONG OnBootloaderMessage( UINT wParam, LONG lParam );
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TWIDDLERDLG_H__FD64FE67_822A_11D6_80D4_0050048A5DF5__INCLUDED_)
